# Good vs. Evil 2.0.6 - Who Will Win This Time?
# Based on code by EdT
# Altered by Iritscen
#
# Starring Griffin, Dr. Kerr (post-fighting school!),
# a Black Ops TCTF soldier, Karen, a training droid,
# a rent-a-cop, a generic TCTF soldier, and, of course,
# Konoko...
# VERSUS
# A Syndicate Striker, a Fury, a Ninja, a Tanker,
# an Elite Striker, and, one-by-one, Barabas, Mukade,
# and, of course, Muro
#
# Eight versus Eight!
# Let the match begin!

# Death Trackers
var int to_check = 0;
var string ai_name;
var int num_char = 16;
var int num_dead = 0;
var bool grif_dead = 0; # did WE kill Griffin?
var bool kerr_dead = 0;
var bool SWAT_dead = 0; # the black ops dude
var bool kar_dead = 0;
var bool droid_dead = 0; # he's not the droid we're looking for anymore
var bool cop_dead = 0;
var bool TCTF_dead = 0;
var bool kon_dead = 0; # if she goes, Good will probably lose
var bool strike_dead = 0;
var bool fury_dead = 0;
var bool elite_dead = 0; # the elite striker
var bool ninja_dead = 0; # the standard ninja, not Mukade
var bool tank_dead = 0;
var bool bar_dead = 0;
var bool muk_dead = 0;
var bool muro_dead = 0; # Good wins!

func void main (void)
{
	#Set the scene
	env_show 2010 0
	gl_fog_blue=.15
	gl_fog_red=.15
	gl_fog_green=.15
	gl_fog_start=.99
	gs_farclipplane_set 5000
	obj_create 20 20

	#Set up Konoko as observer
	chr_invincible 0 1
	chr_givepowerup 0 invis -1
	sleep 120

	#Send Konoko to the right place
	chr_teleport 0 0023
	chr_facetoflag 0 0021
	#ai2_allpassive 1
	ai2_ignore_player = 1
	chr_unstoppable 0 1
		
	#The Good Guys (& Girls)
	ai2_spawn griffin
	chr_set_health griffin 400
	chr_teleport griffin 0023
	chr_facetoflag griffin 0021
		
	ai2_spawn kerr
	chr_set_health kerr 200
	chr_teleport kerr 0023
	chr_facetoflag kerr 0021
		
	ai2_spawn GrifOps03
	chr_set_health GrifOps03 300
	chr_teleport GrifOps03 0023
	chr_facetoflag GrifOps03 0021
		
	ai2_spawn demo3
	chr_set_health demo3 300
	chr_teleport demo3 0023
	chr_facetoflag demo3 0021
		
	ai2_spawn dum_train_shoot2
	chr_set_health dum_train_shoot2 200
	chr_teleport dum_train_shoot2 0023
	chr_facetoflag dum_train_shoot2 0021
		
	#ai2_spawn shinatama
	#chr_set_health shinatama 400
	#chr_teleport shinatama 0023
	#chr_facetoflag shinatama 0021
		
	ai2_spawn fl2_balcony_1
	chr_set_health fl2_balcony_1 200
	chr_teleport fl2_balcony_1 0023
	chr_facetoflag fl2_balcony_1 0021
		
	ai2_spawn OutroTCTF02
	chr_set_health OutroTCTF02 200
	chr_teleport OutroTCTF02 0023
	chr_facetoflag OutroTCTF02 0021
	chr_changeteam OutroTCTF02 Konoko
		
	ai2_spawn evilkonoko
	chr_set_health evilkonoko 400
	chr_teleport evilkonoko 0023
	chr_facetoflag evilkonoko 0021
	chr_changeteam evilkonoko Konoko


	#The Bad Guys (& Girls)

	#Possible teams are:
	#Konoko, TCTF, Syndicate, Neutral, SecurityGuard,
	#RogueKonoko, Switzerland, SyndicateAccessory

	#Bosses enter one at a time, in order of game
				
	ai2_spawn barabus
	chr_set_health barabus 10
	chr_teleport barabus 0018
	chr_facetoflag barabus 0018
		
	ai2_spawn ambush_striker
	chr_set_health ambush_striker 200
	chr_teleport ambush_striker 0018
	chr_facetoflag ambush_striker 0018
		
	ai2_spawn GrifElite03
	chr_set_health GrifElite03 200
	chr_teleport GrifElite03 0018
	chr_facetoflag GrifElite03 0018
		
	ai2_spawn C_Eb27
	chr_set_health C_Eb27 200
	chr_teleport C_Eb27 0018
	chr_facetoflag C_Eb27 0018
	
	ai2_spawn C_Tr28
	chr_set_health C_Tr28 200
	chr_teleport C_Tr28 0018
	chr_facetoflag C_Tr28 0018
		
	ai2_spawn C2_t19
	chr_set_health C2_t19 200
	chr_teleport C2_t19 0018
	chr_facetoflag C2_t19 0018

	#spawn an untouchable Mukade
	ai2_spawn NinjaZip
	chr_changeteam NinjaZip Switzerland
	chr_unstoppable NinjaZip 1
	chr_invincible NinjaZip 1
	chr_teleport NinjaZip 0018
	chr_facetoflag NinjaZip 0021
	ai2_makeaware NinjaZip 0

	#spawn an untouchable Muro
	ai2_spawn BoothMuro01
	chr_changeteam BoothMuro01 Switzerland
	chr_unstoppable BoothMuro01 1
	chr_invincible BoothMuro01 1
	chr_teleport BoothMuro01 0018
	chr_facetoflag BoothMuro01 0018
		
	fork LookForGrifDeath

	chr_wait_health barabus 0
	sleep 120
	fork PostBarabasRegroup

	#when Barabas bites it, sic Mukade on 'em
	chr_set_health NinjaZip 300
	chr_changeteam NinjaZip Syndicate
	chr_unstoppable NinjaZip 0
	chr_invincible NinjaZip 0
	sound_dialog_play c11_40_01superninja
	sound_music_start mus_fitec 0.75

	#the music fades out
	chr_wait_health NinjaZip 0
	sound_music_volume mus_fitec 0.0 2.0
	sound_music_stop mus_fitec

	#Konoko gets a Daodan rush
	sound_dialog_play c07_26a_01konokofx
	chr_animate evilkonoko KONOKOpowerup
	chr_set_health evilkonoko 300

	fork PostMukadeRegroup

	#now that Mukade's definitively KOed, bring in Muro
	chr_wait_health NinjaZip 0
	sleep 10
	chr_set_health BoothMuro01 400
	chr_changeteam BoothMuro01 Syndicate
	chr_unstoppable BoothMuro01 0
	chr_invincible BoothMuro01 0
	sleep 10
	sound_dialog_play c04_17_02muro
	sleep 120
	sound_music_start mus_asian 0.8

	chr_wait_health BoothMuro01 0
	#do something happy - currently, just fades out music
	sound_music_volume mus_asian 0.0 2.0
	sound_music_stop mus_asian
}

func LookForGrifDeath
{
	fork LookForKerrDeath
	chr_wait_health griffin 0
	num_dead = num_dead + 1
	dmsg "Griffin's gonna sleep it off!"
	grif_dead = 1
}

func LookForKerrDeath
{
	fork LookForSWATDeath
	chr_wait_health kerr 0
	dmsg "Kerr's fallen and he can't get up!"
	kerr_dead = 1
}

func LookForSWATDeath
{
	fork LookForKarDeath
	chr_wait_health GrifOps03 0
	dmsg "Black Ops Down!"
	SWAT_dead = 1
}

func LookForKarDeath
{
	fork LookForDroidDeath
	chr_wait_health demo3 0
	dmsg "Karen's down! That wasn't supposed to happen!"
	kar_dead = 1
}

func LookForDroidDeath
{
	fork LookForCopDeath
	chr_wait_health dum_train_shoot2 0
	dmsg "The droid crashed!"
	droid_dead = 1
}

func LookForCopDeath
{
	fork LookForTCTFDeath
	chr_wait_health fl2_balcony_1 0
	dmsg "Rent-A-Cop needs an ambulance!"
	cop_dead = 1
}

func LookForTCTFDeath
{
	fork LookForKonDeath
	chr_wait_health OutroTCTF02 0
	dmsg "TCTF #1024QR49 is down! He was my favorite!"
	TCTF_dead = 1
}

func LookForKonDeath
{
	fork LookForBarDeath
	chr_wait_health evilkonoko 0
	dmsg "Uh-oh. Konoko's KOed! Ganbarimashita!"
	kon_dead = 1
}

func LookForBarDeath
{
	fork LookForStrikeDeath
	chr_wait_health barabus 0
	dmsg "Barabas is napping. Don't poke him."
	bar_dead = 1
}

func LookForStrikeDeath
{
	fork LookForFuryDeath
	chr_wait_health ambush_striker 0
	dmsg "The striker was struck down."
	strike_dead = 1
}

func LookForFuryDeath
{
	fork LookForEliteDeath
	chr_wait_health GrifElite03 0
	dmsg "That Fury is either KOed or constipated."
	fury_dead = 1
}

func LookForEliteDeath
{
	fork LookForNinjaDeath
	chr_wait_health C_Eb27 0
	dmsg "The Elite Striker met his match."
	elite_dead = 1
}

func LookForNinjaDeath
{
	fork LookForTankDeath
	chr_wait_health C_Tr28 0
	dmsg "That's one less ninja to worry about."
	ninja_dead = 1
}

func LookForTankDeath
{
	fork LookForMuroDeath
	chr_wait_health C2_t19 0
	dmsg "The tanker tanked. Finally."
	tank_dead = 1
}

func LookForMuroDeath
{
	fork LookForMukDeath
	chr_wait_health BoothMuro01 0
	dmsg "Blam! Love, little sister"
	muro_dead = 1
}

func LookForMukDeath
{
	chr_wait_health NinjaZip 1
	ai2_kill NinjaZip
	dmsg "Mukade's not going to be sneaking again for a while."
	muk_dead = 1	
}

func PostBarabasRegroup
{
	# bring char.s back into action
	if (grif_dead ne 1)
	{
		ai2_forget griffin barabus
		#chr_teleport griffin 0023
		ai2_movetoflag griffin 0023
		chr_facetoflag griffin 0021
		sleep 60
	}
	if (kerr_dead ne 1)
	{
		ai2_forget kerr barabus
		#chr_teleport kerr 0023
		ai2_movetoflag kerr 0023
		chr_facetoflag kerr 0021
		sleep 60
	}
	if (SWAT_dead ne 1)
	{
		ai2_forget GrifOps03 barabus
		#chr_teleport GrifOps03 0023
		ai2_movetoflag GrifOps03 0023
		chr_facetoflag GrifOps03 0021
		sleep 60
	}
	if (kar_dead ne 1)
	{
		ai2_forget demo3 barabus
		#chr_teleport demo3 0023
		ai2_movetoflag demo3 0023
		chr_facetoflag demo3 0021
		sleep 60
	}
	if (droid_dead ne 1)
	{
		ai2_forget dum_train_shoot2 barabus
		#chr_teleport dum_train_shoot2 0023
		ai2_movetoflag dum_train_shoot2 0023
		chr_facetoflag dum_train_shoot2 0021
		sleep 60
	}
	if (cop_dead ne 1)
	{
		ai2_forget fl2_balcony_1 barabus
		#chr_teleport fl2_balcony_1 0023
		ai2_movetoflag fl2_balcony_1 0023
		chr_facetoflag fl2_balcony_1 0021
		sleep 60
	}
	if (TCTF_dead ne 1)
	{
		ai2_forget OutroTCTF02 barabus
		#chr_teleport OutroTCTF02 0023
		ai2_movetoflag OutroTCTF02 0023
		chr_facetoflag OutroTCTF02 0021
		sleep 60
	}
	if (kon_dead ne 1)
	{
		ai2_forget evilkonoko barabus
		#chr_teleport evilkonoko 0023
		ai2_movetoflag evilkonoko 0023
		chr_facetoflag evilkonoko 0021
	}
}

func PostMukadeRegroup
{
	# bring char.s back into action
	if (grif_dead ne 1)
	{
		ai2_forget griffin NinjaZip
		#chr_teleport griffin 0023
		ai2_movetoflag griffin 0023
		chr_facetoflag griffin 0021
		sleep 60
	}
	if (kerr_dead ne 1)
	{
		ai2_forget kerr NinjaZip
		#chr_teleport kerr 0023
		ai2_movetoflag kerr 0023
		chr_facetoflag kerr 0021
		sleep 60
	}
	if (SWAT_dead ne 1)
	{
		ai2_forget GrifOps03 NinjaZip
		#chr_teleport GrifOps03 0023
		ai2_movetoflag GrifOps03 0023
		chr_facetoflag GrifOps03 0021
		sleep 60
	}
	if (kar_dead ne 1)
	{
		ai2_forget demo3 NinjaZip
		#chr_teleport demo3 0023
		ai2_movetoflag demo3 0023
		chr_facetoflag demo3 0021
		sleep 60
	}
	if (droid_dead ne 1)
	{
		ai2_forget dum_train_shoot2 NinjaZip
		#chr_teleport dum_train_shoot2 0023
		ai2_movetoflag dum_train_shoot2 0023
		chr_facetoflag dum_train_shoot2 0021
		sleep 60
	}
	if (cop_dead ne 1)
	{
		ai2_forget fl2_balcony1 NinjaZip
		#chr_teleport fl2_balcony1 0023
		ai2_movetoflag fl2_balcony1 0023
		chr_facetoflag fl2_balcony1 0021
		sleep 60
	}
	if (TCTF_dead ne 1)
	{
		ai2_forget OutroTCTF02 NinjaZip
		#chr_teleport OutroTCTF02 0023
		ai2_movetoflag OutroTCTF02 0023
		chr_facetoflag OutroTCTF02 0021
		sleep 60
	}
	if (kon_dead ne 1)
	{
		ai2_forget evilkonoko NinjaZip
		#chr_teleport evilkonoko 0023
		ai2_movetoflag evilkonoko 0023
		chr_facetoflag evilkonoko 0021
	}
}